package com.ruoyi.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ruoyi.domain.ReviewDetails;
import com.ruoyi.domain.ReviewKeyPoint;
import com.ruoyi.domain.ReviewStandard;
import com.ruoyi.web.request.ReviewFindListRequest;
import com.ruoyi.web.response.ReviewDetailsListResponse;
import com.ruoyi.web.response.ReviewKeyPointListResponse;
import com.ruoyi.web.response.ReviewSceneListResponse;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface ReviewKeyPointMapper extends BaseMapper<ReviewKeyPoint> {

    List<ReviewKeyPoint> findByStandardList(@Param("reviewStandardList") List<ReviewStandard> reviewStandardList);

    // 条件查询要点列表
    List<ReviewKeyPoint> findKeyPointList(ReviewFindListRequest request);

    // 根据细则列表查询要点列表
    List<ReviewKeyPoint> findByDetailsList(@Param("detailsList") List<ReviewDetails> detailsList);

    /*
     * 发起评审-获取要点列表
     * */
    List<ReviewKeyPointListResponse> getKeyPointList(@Param("standardId") Long standardId);

    /*
     * 发起评审-获取细则列表
     * */
    List<ReviewDetailsListResponse> getDetailsList(@Param("keypointId") Long keypointId);

    /*
     * 发起评审-获取场景列表
     * */
    List<ReviewSceneListResponse> getSceneList(@Param("detailsId") Long detailsId);
}
