package com.ruoyi.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ruoyi.domain.ReviewKeyPoint;
import com.ruoyi.domain.ReviewStandard;
import com.ruoyi.web.request.*;
import com.ruoyi.web.response.*;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;


@Repository
public interface ReviewStandardMapper extends BaseMapper<ReviewStandard> {

    List<ReviewStandard> findListByStandardIdAndType(@Param("standardId") Long standardId, @Param("type") String type);

    /**
     * 查询标准列表
     *
     * @param request
     * @return
     */
    List<ReviewStandardResponse> selectReviewStandardList(ReviewStandardListByPageRequest request);

    /**
     * 根据标准主键ID查询车型试验的检验内容
     * @param id
     * @return
     */
    List<ReviewStandardTestInspectionContentResponse> selectTestInspectionContent(Long id);

    List<ReviewStandardListResponse> findReviewStandardList(ReviewStandardListRequest request);

    // 根据要点列表查询标准列表
    List<ReviewStandard> findByKeyPointList(@Param("keyPointList") List<ReviewKeyPoint> keyPointList, @Param("request") ReviewFindListRequest request);


    /*
     * 标准内容库新界面接口
     * */
    List<StandardTypeListResponse> findTypeByStandard(@Param("request") StandardListNewRequest request);

    /*
     * 标准内容库新界面接口
     * */
    List<ReviewStandardChapterListResponse> findChaptersByStandard(@Param("request") StandardListNewRequest request);

    // 获取标准信息
    ReviewStandardResponseNew selectReviewStandardById(@Param("key") Long key);


    /*
     * 查询当前标准下的所有id集合
     * */
    List<Long> getIdList(@Param("getUseCaseRequestNew") GetUseCaseRequestNew getUseCaseRequestNew);

    /*
     * 查询当前标准下的所有要点id集合
     * */
    List<Long> getKeypointIdList(@Param("getKeypointListRequest") GetKeypointListRequest getKeypointListRequest);

    /*
    * 获取要点id列表
    * */
    List<KeypointList> getKeypointListByIdList(@Param("idList") List<Long> idList);

    List<Long> getDetailsIdList(@Param("deleteDetailsRequest") DeleteDetailsRequest deleteDetailsRequest);

    // 获取所有要点ID列表
    List<Long> getDelKeypointIdList(@Param("deleteDetailsRequest") DeleteDetailsRequest deleteDetailsRequest);

    // 获取与 KeypointList 关联的 DeleteDetails
    List<DeleteDetails> getDeleteDetailsByKeypointId(@Param("id") Long id);
}
